%This script runs the OMP2D (it can also run SPMP2D, a low memory version of OMP2D) routines
%The image is read from the Lukas corpus and should be input as a number from 1 to 20.
%The approximation is carried out in the wavelet domain (using the waveletcdf97 fuction)
%By default the partition is of length NbxNb=16x16 (to change it change 'Nb' below)
%The  the setting for reproducing Table 1 in the paper are read by the script get_settings_table1_wd.
%The dictionary is a mixed dictionary. To change the dictionary input Dx and Dy
%
%By default this script runs the  C++ Mex of OMP2D to use the Matlab version  uncomment line 82  and comment line 83  
%To run SPMP2D (low memory version of OMP2D) comment line 19 and uncomment 23 (or 24 for MP2D).To run the Matlab versions 
%(about 6 times slower) uncomment line 85  and comment line 86. 
%The C++ Mex source files for OMP2D and SPMP2D can be found on the link below
%http://www.nonlinear-approx.info/examples/node1.html
%
clear ImageNumber

ImageNumber=input('Input the Image Number ')
%
%
method='OMP2D' %comment to run SPMP2D or MP2D
%
get_settings_Fig6_wd
%-------uncomment line 19 for SPMP2D or line 20 for MP2D--------------------
%lstep=1;method='SPMP2D'
%lstep=-1;method='MP2D'
%---------------------------------------------------------------------------
%
tic 
[mImage, sInfo, map] = LoadImage(ImagePath); %load the image 
[mI, bitDepth] = MImage2Grey(mImage, sInfo, map);%convert it to Grey
%
bw=Nb
blockWidth=bw
%
clear  Di1 Di2 Q c cbeta h
%===input the mixed dictionary- to change it input Dx Dy.===
get_mixed_dict_wd
%===========================================================

s=floor(size(mI)/bw)

mI=mI(1:s(1)*bw,1:s(2)*bw); %rezise the images to be divisible by bw
mI2=mI;  %keep the pixel image
wlevel=5;

mI= waveletcdf97(mI2, wlevel);  %transform to wavelet domain

MaxInt=max(max(mI2));
MaxIntb=255;

dz=zeros(bw,1);

[cmI, nYBlocks, nXBlocks] = BlockImage(mI, blockWidth); %for blocking 

[Lx,Ly]=size(cmI{1,1});
delta=1/(Lx*Ly);
NBY=nYBlocks;
NBX=nXBlocks;

cmIa= cell(nYBlocks,nXBlocks);
No=[];
tol=MaxIntb^2/(10^(pss/10))
toln=5e-4;
tol2=sqrt(tol*(Lx*Ly))
toln2=sqrt(toln*Lx*Ly);
nCoe=0;
darkb=0;
%---------------for SPMP2D-----------------------
Max=150000; %Maximum numer of iterations this is blockwith dependent!
Maxp=150000;
%-------------------------------------------------
indx=[];
indy=[];
fixat=0;
%---------------------------------------------------
q=0;
for i = 1:nYBlocks
for j = 1:nXBlocks
q=q+1;
B=cmI{i,j};
 if sum(sum(B).^2)*delta>1e-5 %if the intensity of the whole plock is zero use the zeor block
if strcmp(method,'OMP2D')
%[h,Di1{q},Di2{q},cbeta{q},c{q},Q]=OMP2D_m(B,Dx,Dy,tol,No,indx,indy);
[h,Di1{q},Di2{q},cbeta,c{q},Q,vin]=OMP2D_Mex(B,Dx,Dy,tol2^2,No,indx,indy);
else
%[h,Di1{q},Di2{q},c{q}]=SPMP2D_new(B,Dx,Dy,tol,No,toln,lstep,Max,Maxp,indx,indy);
[h,Di1{q},Di2{q},c{q}]=SPMP2D_Mex(B,Dx,Dy,tol2,No,toln2,lstep,Max,Maxp,indx,indy);
end
if c{q}==0 darkb=darkb+1; end
cmIa{i,j}=h ; % h is the appoximation of the block
nCoe = nCoe + numel(c{q}); %count the total coefficients
else
    cmIa{i,j}=dz*dz'; %zero block (dark ernegy)
    nCoe = nCoe + 1;
    darkb=darkb+1;
    c{q}=[];
    Di1{q}=[];
    Di2{q}=[];
end
end
end 
nCoe2=nCoe-darkb
fprintf('Time for the approximation.\n')
toc
clear mImage
mIc=cell2mat(cmIa);%get the images from the blocks
mImage=waveletcdf97(mIc,-wlevel);%get back to the pixes domain
PSNR=CalcPSNR2(mI2,mImage,MaxIntb) % PSNR of the approximation
SR= numel(mI2)/nCoe2 % Sparsity ratio
fprintf('number of dark blocks.\n') 
darkb
MSSIM=ssim(mI2, mImage)
%
%Quantization 
%
tic
[cq,onein,cDi1,cDi2,csi,sc]=quant_wd(mI2,c,Di1,Di2,NBX,NBY,del,thr,Dx,Dy,wlevel);
%
NN=NBX*NBY;%number of blocks
%
[xC,xCC,xS]=make_strings_wd(cq,onein,csi,sc,NN);
%
%Save the strings and shows the size of the file
%
SR_after_Quantization=numel(mI2)/(numel(xCC{1}))
fileSC='XRayFile/Sparse_File_WD.mat';
save(fileSC,'xC','xCC','xS','del','NBX');
hs=dir(fileSC);
bpp=hs.bytes*8/numel(mI)

fprintf('Time for making the file \n')
toc
fprintf('The name of the  file is: ')

disp(fileSC);


%--------------------------------------------------------------------------------------------------------

%Copyright (C) 2017 Laura REBOLLO-NEIRA, Mathematics Department Aston University.
%This is free software; you can redistribute it and/or modify it under the terms
%of the GNU General Public License as published by the Free Software Foundation; either
%version 2 of the License, or (at your option) any later version.
%
%This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
%without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
%See the GNU General Public License for more details.
%
%You should have received a copy of the GNU General Public License along with this program;
%If not, see <http://www.gnu.org/licenses/>.

%--------------------------------------------------------------------------------------------------------
