function [cc,nlind,cs]=NLA_Wcon(Icon,pss);
%Nonlinear Selection of Wavelet coefficients
%Input
%       Icon Image in the wavelet doamin
%       pss  for the approximation tolerance
%
%Output
%       cc full set of coefficients (including the zeros)
%       nlind indices for the nonzeor coeffeints  
%       coeffeints of the selected indices only
%
NXcon=size(Icon,1);
NYcon=size(Icon,2);
%
delta=1/(NXcon*NYcon);
c=Icon(:); %conver the conner into a vector
tol=sqrt(255^2/(10^(pss/10)));%tolerance error
%
cc=zeros(size(c));%sort wav. coeff(smalest to largest abs values)
[cs,ic]=sort(abs(c));
nerror=cumsum(cs.^2)*delta;%error norm as a function of number of coefficients
nlind=ic(nerror>=tol^2);%selects the indices of largest coefficients up to error tol
cs=c(nlind); %reduced coefficients
cc(nlind)=cs; %wav.  coef. with the zeros as well
